/* ERD - Copyright (C) 2005 bakunin - Andrea Marchesini 
 *                              <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include "erd.h"

static SSL_CTX *ctx = NULL;
static SSL_METHOD *meth;

SSL_CTX *
ssl_get_ctx (void)
{
  return ctx;
}

void
ssl_init (void)
{
//  SSL_load_error_strings ();
  SSL_library_init ();
}

void
ssl_certificate (struct erd_config *conf)
{
  meth = SSLv23_server_method ();
  if (!(ctx = SSL_CTX_new (meth)))
    fatal ("SSL CTX error.");

  if (SSL_CTX_use_certificate_file
      (ctx, conf->input_certificate, SSL_FILETYPE_PEM) < 1)
    fatal ("SSL CTX certificate error.");

  if (SSL_CTX_use_PrivateKey_file
      (ctx, conf->input_privatekey, SSL_FILETYPE_PEM) < 1)
    fatal ("SSL CTX privatekey error.");

  if (!SSL_CTX_check_private_key (ctx))
    fatal ("SSL CTX privatekey does not math the certificate public key.");
}

/* EOF */
